/*
 * calculation !! 
 *
 * $Header: cal.c,v 0.6 94/10/31 15:16:46 miyazawa Rel $
 */

#include "modoki.h"

#define _MAX 48
#define TOP_X 60
#define TOP_Y 40

static int card[_MAX];
static int sp;
static int found[8];
static int holdcard;
static int from;
static struct tableau *tableau[4];
static int px[9], py[9];

void
initCal()
{
	static int check();
	static void restart();
	static int whenHold();
	static int whenNotHold();

	_ckhook = check;
	_rshook = restart;
	_when_hold = whenHold;
	_when_not_hold = whenNotHold;
	current = CALCULATION;
	(*_rshook)();
	(*_ckhook)();
}

static void
restart()
{
	register i, j;
	struct tableau *temp;

	srandom(randomseed);
	XUnmapSubwindows(dpy, Table);
	clearStack();

	for (i = 0; i < 4; i++) {
		tfree(&tableau[i]);
	}

	px[0] = TOP_X;
	py[0] = TOP_Y;

	for (i = 0; i < 4; i++) {
		px[i + 1] = TOP_X + 60;
		px[i + 5] = TOP_X;
		py[i + 1] = py[i + 5] = TOP_Y + 70 * (i + 1);
	}

	found[0] = 26;
	found[1] = 40;
	found[2] = 15;
	found[3] = 3;

	for (j = 0, i = 0; i < 52; i++) {
		if (i == 26 || i == 40 || i == 15 || i == 3) {
			continue;
		}
		card[j++] = i;
	}
	for (i = 0; i < _MAX; i++) {
		swap(&card[random() % _MAX], &card[i]);
	}

	for (i = 0; i < 4; i++) {
		PUTCARD(found[i], i + 5);
	}
	for (i = 1; i < 5; i++) {
		PUTCARD(FRAME, i);
	}
	PUTCARD(card[0], 0);

	sp = 0;
	holdcard = -1;
	havecard = False;
	from = 0;
	_status = 0;
}

static int
check()
{
	register i, j;
	int sou, des;

	sou = des = 0;
	autopilot = False;
	for (i = 0; i < 4; i++) {
		if (NUMB(found[i]) != KING) {
			goto skip;
		}
	}
	return (1);
skip:
	for (i = 0; i < 4; i++) {
		if (tableau[i] != NULL) {
			for (j = 0; j < 4; j++) {
				if (NUMB(found[j] + j + 1) ==
				    NUMB(tableau[i]->n)
				    && NUMB(found[j]) != KING) {
					sou = i + 1;
					des = j + 5;
					goto ok;
				}
			}
		}
	}
	if (sp < _MAX) {
		for (j = 0; j < 4; j++) {
			if (NUMB(found[j] + j + 1) == NUMB(card[sp])
			    && NUMB(found[j]) != KING) {
				sou = 0;
				des = j + 5;
				goto ok;
			}
		}
	}
	else {
		return (-1);
	}
ok:
	return (0);
}

static int
whenNotHold(pos)
int pos;
{
	if (pos < 5 && pos > 0) {
		if (tableau[pos - 1] != NULL) {
			holdcard = tableau[pos - 1]->n;
			havecard = True;
			from = pos;
			return (0);
		}
	}
	else if (pos == 0) {
		holdcard = card[sp];
		havecard = True;
		from = pos;
		return (0);
	}
	return (-1);
}

static int
whenHold(pos)
int pos;
{
	struct tableau *temp;

	if (pos == from || pos < 0) {
		holdcard = -1;
		return (-1);
	}
	if (pos > 4) {
		if (NUMB(found[pos - 5] + pos - 4) == NUMB(holdcard)
		  && NUMB(found[pos - 5]) != KING) {
			if (px[pos] < 16) {
				PUTCARD(found[pos - 5], pos);
				px[pos] = TOP_X;
			}
			found[pos - 5] = holdcard;
			PUTCARD(holdcard, pos);
			if (from) {
				temp = tableau[from - 1];
				tableau[from - 1] = temp->next;
				if (temp->next != NULL) {
					px[from] = temp->next->tmp;
					PUTCARD(temp->next->n, from);
				}
				else {
					px[from] = TOP_X + 60;
				}
				XtFree((XtPointer) temp);
			}
			else {
				if (sp < _MAX - 1) {
					PUTCARD(card[++sp], 0);
				}
				else {
					sp = _MAX;
				}
			}
			holdcard = -1;
			return (0);
		}
	}
	else if (pos > 0 && pos < 5 && from == 0) {
		if (tableau[pos - 1] != NULL) {
			px[pos] += 8;
		}
		temp = talloc();
		temp->next = tableau[pos - 1];
		temp->tmp = px[pos];
		temp->n = holdcard;
		tableau[pos - 1] = temp;
		PUTCARD(holdcard, pos);
		holdcard = -1;
		if (sp < _MAX - 1) {
			PUTCARD(card[++sp], 0);
		}
		else {
			sp = _MAX;
		}
		return (0);
	}
	holdcard = -1;
	return (-1);
}
