/*
 * golf !! 
 *
 * $Header: glf.c,v 0.6 94/10/31 15:17:19 miyazawa Rel $
 */

#include "modoki.h"

#define _MAX 52
#define _MIN 17
#define HX 40
#define VY 20
#define TOP_X 50
#define TOP_Y 50

static int card[_MAX];
static int found;
static int from;
static int sp[8];
static int px[9], py[9];

void
initGlf()
{
	static int check();
	static void restart();
	static int whenHold();
	static int whenNotHold();

	_ckhook = check;
	_rshook = restart;
	_when_hold = whenHold;
	_when_not_hold = whenNotHold;
	current = GOLF;
	(*_rshook)();
	(*_ckhook)();
}

static void
restart()
{
	register i, j;
	struct tableau *temp;
	static long seed;

	srandom(randomseed);
	XUnmapSubwindows(dpy, Table);
	clearStack();

	for (i = 0; i < 7; i++) {
		px[i + 1] = TOP_X + 60 * i;
		py[i + 1] = TOP_Y;
		sp[i + 1] = 4;
	}
	py[0] = py[8] = TOP_Y + 216;
	px[0] = px[2];
	px[8] = px[6];

	sp[0] = _MIN - 1;

	for (j = 0, i = 0; i < 52; i++) {
		card[j++] = i;
	}
	for (i = 0; i < _MAX; i++) {
		swap(&card[random() % _MAX], &card[i]);
	}

	PUTCARD(FACE, 0);
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 7; j++) {
			py[j + 1] += VY;
			PUTCARD(card[_MIN + i * 7 + j], j + 1);
		}
	}
	for (j = 0; j < 7; j++) {
		py[j + 1] += VY;
		PUTCARD(card[_MIN + 28 + j], j + 1);
	}
	found = card[sp[0]];
	PUTCARD(found, 8);
	sp[0]--;
	from = 2;
	havecard = False;
	_status = 0;
}

static int
check()
{
	register i;
	int des;
	int temp;

	des = 0;
	autopilot = False;

	for (i = 1; i < 8; i++) {
		if (sp[i] >= 0) {
			goto skip;
		}
	}
	return (1);
skip:
	for (i = 1; i < 8; i++) {
		if (sp[i] >= 0) {
			temp = card[_MIN + sp[i] * 7 + i - 1];
			if (NUMB(found) != KING &&
			    (NUMB(found) + 1 == NUMB(temp) ||
			     NUMB(found) - 1 == NUMB(temp))) {
				des = i;
				goto ok;
			}
		}
	}
	if (sp[0] < 0) {
		return (-1);
	}
	ok:
	return (0);
}

static int
whenHold(pos)
int pos;
{
	return (0);
}

static int
whenNotHold(pos)
int pos;
{
	int temp;

	if (pos < 0) {
		return (-1);
	}
	if (pos == 0) {
		if (sp[0] >= 0) {
			found = card[sp[0]];
			PUTCARD(found, 8);
			sp[0]--;
			if (sp[0] < 0) {
				XUnmapWindow(dpy, _decks[JOKER].self);
			}
			return (0);
		}
		return (-1);
	}
	temp = card[_MIN + sp[pos] * 7 + pos - 1];
	if (NUMB(found) != KING && (NUMB(found) + 1 == NUMB(temp) ||
		   NUMB(found) - 1 == NUMB(temp))) {
		found = temp;
		PUTCARD(temp, 8);
		if (--sp[pos] < 0) {
			sp[pos] = -1;
		}
		else {
			if (py[pos] > 20)
				py[pos] -= VY;
			PUTCARD(card[_MIN + sp[pos] * 7 + pos - 1],
				pos);
		}
		return (0);
	}
	return (-1);
}
