/*
 * xsols -- Solitaire card games for X11
 *
 * $Id: /tmp_mnt/netr/home2/mmb/miyazawa/private/pm/RCS/modoki.h,v 0.7 1992/09/25 12:46:07 miyazawa Exp miyazawa $
 */

#include <stdio.h>
#include <X11/Intrinsic.h>

struct card {
	Window self;
	int pos;
	int n;
};

struct tableau {
	int n;
	int tmp;
	struct tableau *next;
};

#define BLACK 0
#define RED   1

#define CLUB  0
#define DIA   1
#define HEART 2
#define SPADE 3

#define ACE   0
#define TWO   1
#define THREE 2
#define FOUR  3
#define FIVE  4
#define SIX   5
#define SEVEN 6
#define EIGHT 7
#define NINE  8
#define TEN   9
#define JACK  10
#define QUEEN 11
#define KING  12


#define SUIT(n) ((n)/13)
#define NUMB(n) ((n)%13) /* NUMB returns 0 origin number */
#define COLOR(n) ((SUIT(n)%3)?RED:BLACK)
#define REDP(n) (SUIT(n)%3)
#define BLACKP(n) (!REDP(n))
#define BINDP(a,b) (((a)>=0)&&((a)+1==(b)&&NUMB(b)))
#define STRAIGHTP(a,b) (NUMB(a)+1==NUMB(b))
#define SUITP(a,b) (SUIT(a)==SUIT(b))
#define NUMBP(a,b) (NUMB(a)==NUMB(b))
#define COLORP(a,b) (COLOR(a)==COLOR(b))
#define CARD(suit,num) ((suit)*13+(num))

#define JOKER 52
#define FACE  53
#define FRAME 54
#define VARIETY (FRAME+1)

#define GAMEMAX 9
#define CALCULATION "calculation"
#define CANFIELD "canfield"
#define CORNERS "corners"
#define GOLF "golf"
#define KLONDIKE "klondike"
#define PYRAMID "pyramid"
#define QUADRILLE "quadrille"
#define TOWERS "towers"
#define SHUFFLE "shuffle"

extern struct tableau * talloc();
extern void tfree();
extern void swap();

extern Display *dpy;
extern int scr;
extern Window Table;
extern struct card _decks[];
extern int _status;
extern void (*_rshook) ();
extern int (*_ckhook) ();
extern int (*_when_hold)();
extern int (*_when_not_hold)();
extern String current;
extern String savefile;
extern Boolean havecard;
extern Boolean autopilot;
extern long randomseed;
extern void swap();
extern void clearStack();
extern void pushCard();
extern struct tableau *popCard();

#define talloc() XtNew(struct tableau)
#define PUTCARD(n,p) putCard(px[p], py[p], n, p)

#ifdef DEBUG
#define SUITC(a) ("CDHS"[SUIT(a)])
#define NUMBC(a) ("A23456789TJQK"[SUIT(a)])
#endif
