/*
 * pyramid !! 
 *
 * $Header: pyd.c,v 0.7 94/10/31 15:17:22 miyazawa Rel $
 */

#include "modoki.h"

#define _MAX 52
#define _MIN 28
#define TOP_X 90
#define TOP_Y 30

struct pyramid {
	char ul, ur, dl, dr;
};

static int card[_MAX];
static int sp;
static int num;
static int from;
static int sou, des, dz, edg;
static int px[30], py[30];
static int holdcard;
static struct tableau *tableau; 
static struct pyramid found[_MIN];

static void hansoku();

void
initPyd()
{
	static int check();
	static void restart();
	static int whenHold();
	static int whenNotHold();

	_ckhook = check;
	_rshook = restart;
	_when_hold = whenHold;
	_when_not_hold = whenNotHold;
	current = PYRAMID;
	(*_rshook)();
	(*_ckhook)();
}

static void
restart()
{
	register i, j;
	register xx, yy, nn;
	static long seed;

	srandom(randomseed);
	XUnmapSubwindows(dpy, Table);
	clearStack();

	tfree(&tableau);
	for (i = 0; i < JOKER; i++) {
		card[i] = i;
	}
	px[0] = TOP_X + 220;
	px[1] = TOP_X + 280;
	py[0] = py[1] = TOP_Y;

	for (i = 0; i < _MAX; i++) {
		swap(&card[random() % _MAX], &card[i]);
	}
	nn = 0;
	xx = TOP_X + 120;
	yy = TOP_Y;
	for (i = 0; i < 7; i++) {
		for (j = 0; j < i + 1; j++) {
			px[nn + 2] = xx + j * 40;
			py[nn + 2] = yy;
			found[nn].ul = (j == 0 ? -1 : nn - i - 1);
			found[nn].ur = (j == i ? -1 : nn - i);
			if (i != 6) {
				found[nn].dl = nn + (i + 1);
				found[nn].dr = nn + (i + 2);
				putCard(px[nn + 2], py[nn + 2],
					card[nn], nn + 2);
			}
			else {
				found[nn].dl = found[nn].dr = -1;
				putCard(px[nn + 2], py[nn + 2],
					card[nn], nn + 2);
			}
			nn++;
		}
		xx -= 20;
		yy += 30;
	}

	sp = _MIN;
	holdcard = -1;
	havecard = False;
	from = 0;
	edg = 23;

	PUTCARD(card[sp], 0);
	PUTCARD(FRAME, 1);
	_status = 0;
}

static int
check()
{
	int tmp;
	int ii, jj;
	int i1, j1;

	autopilot = False;
	sou = des = -1;
	dz = 0;
	if (tableau == NULL && sp == _MAX && edg < 2) {
		return (1);
		}
	if (edg > 1) {
		/* if card exists on pyramid */
		tmp = 0;
		while (found[tmp].dl >= 0) {
			tmp = found[tmp].dl;
		}
		while (found[tmp].dr >= 0) {
			tmp = found[tmp].dr;
		}
		/* take left under card */
		ii = tmp;
		i1 = j1 = -1;
		while (ii != i1) {	/* until cannot move */
			i1 = ii;
			/* the card is 13 ? */
			if (NUMB(card[ii]) == KING) {
				sou = ii + 2;
				goto ok;
			}
			/* compare with pile */
			if (tableau != NULL) {
				if (NUMB(card[ii]) + NUMB(tableau->n) == 11) {
					sou = ii + 2;
					des = 1;
					goto ok;
				}
			}
			/* left upper */
			if ((tmp = found[ii].ul) >= 0) {
				if (NUMB(card[tmp]) + NUMB(card[ii]) == 11 &&
					found[tmp].dl < 0) {
					sou = ii + 2;
					des = tmp + 2;
					dz = 3;
					goto ok;
				}
			}
			/* right upper */
			if ((tmp = found[ii].ur) >= 0) {
				if (NUMB(card[tmp]) + NUMB(card[ii]) == 11 &&
					found[tmp].dr < 0) {
					sou = ii + 2;
					des = tmp + 2;
					dz = 4;
					goto ok;
				}
			}
			/* stock */
			if (sp < _MAX) {
				if (NUMB(card[ii]) + NUMB(card[sp]) == 11) {
					sou = ii + 2;
					des = 0;
					goto ok;
				}
			}
			/* compare alive cards in seaquecnce */
			jj = ii;
			while (jj != j1) {
				j1 = jj;
				if ((tmp = found[jj].ur) < 0) {
					goto check1;
				}
				while (found[tmp].dr < 0) {
					if ((tmp = found[tmp].ur) < 0) {
						goto check1;
					}
				}
				while (found[tmp].dr >= 0) {
					tmp = found[tmp].dr;
				}
				jj = tmp;
check1:
				if (NUMB(card[ii]) + NUMB(card[jj]) == 11) {
					sou = ii + 2;
					des = jj + 2;
					goto ok;
				}
			}
			if ((tmp = found[ii].ur) < 0) {
				goto check2;
			}
			while (found[tmp].dr < 0) {	
				if ((tmp = found[tmp].ur) < 0) {
					goto check2;
				}
			}
			while (found[tmp].dr >= 0){
				tmp = found[tmp].dr;
			}
			ii = tmp;
check2:
			;
		}
	}
	/* is stock 13 ? */
	if (sp < _MAX) {
		if (NUMB(card[sp]) == KING) {
			sou = 0;
			goto ok;
		}
		/* pile & stock */
		if (tableau != NULL &&
			NUMB(tableau->n) + NUMB(card[sp]) == 11) {
			sou = 0;
			des = 1;
			goto ok;
		}
	}
	else {
		return (-1);
	}
ok:
	return (0);
}

static int
whenNotHold(pos)
int pos;
{
	if (pos < 0) {
		return (-1);
	}
	else if (pos == 0) {
		holdcard = card[sp];
		havecard = True;
		from = pos;
	}
	else if (pos == 1) {
		if (tableau == NULL) {
			return (-1);
		}
		holdcard = tableau->n;
		havecard = True;
		from = pos;
	}
	else {
		if (found[pos - 2].dl >= 0 || found[pos - 2].dr >= 0) {
			return (-1);
		}
		holdcard = card[pos - 2];
		havecard = True;
		from = pos;
	}
	if (NUMB(holdcard) == KING) {
		from = -1;
		hansoku(pos);
	}
	return (0);
}

static int
whenHold(pos)
int pos;
{
	struct tableau *temp;
	int tmp;

	if (pos == from || pos < 0) {
		holdcard = -1;
		return (-1);
	}
	if (pos == 0) {
		num = card[sp];
	}
	else if (pos == 1) {
		if (tableau == NULL) {
			num = -1;
		}
		else {
			num = tableau->n;
		}
	}
	else {
		if (found[pos - 2].dl < 0 && found[pos - 2].dr < 0) {
			num = card[pos - 2];
		}
		else if (found[pos - 2].dl == from - 2 &&
			found[pos - 2].dr < 0) {
			num = card[pos - 2];
		}
		else if (found[pos - 2].dr == from - 2 &&
			found[pos - 2].dl < 0) {
			num = card[pos - 2];
		}
		else {
			holdcard = -1;
			return (-1);
		}
	}
	if (NUMB(num) + NUMB(holdcard) == 11) {
		if (from > 1) {
			if ((tmp = found[from - 2].ul) >= 0) {
				found[tmp].dr = -1;
			}
			if ((tmp = found[from - 2].ur) >= 0) {
				found[tmp].dl = -1;
			}
		}
		hansoku(pos);
		return (0);
	}
	else {
		if (from == 0 && pos == 1) {
			if (tableau != NULL) {
				py[pos] += 12;
			}
			temp = talloc();
			temp->next = tableau;
			temp->tmp = py[pos];
			temp->n = holdcard;
			tableau = temp;
			PUTCARD(holdcard, pos);
			if (sp < _MAX - 1) {
				PUTCARD(card[++sp], 0);
			}
			else {
				sp = _MAX;
			}
			holdcard = -1;
			return (0);
		}
	}
	holdcard = -1;
	return (-1);
}

static void
hansoku(pos)
int pos;
{
	struct tableau *temp;
	int tmp;

	XUnmapWindow(dpy, _decks[holdcard].self);
	if (pos > 1) {
		XUnmapWindow(dpy, _decks[card[pos -2]].self);
		if ((tmp = found[pos - 2].ul) >= 0) {
			found[tmp].dr = -1;
		}
		if ((tmp = found[pos - 2].ur) >= 0) {
			found[tmp].dl = -1;
		}
	}
	if (pos == 0) {
		XUnmapWindow(dpy, _decks[card[sp]].self);
	}
	if (from == 0 || pos == 0) {
		if (sp < _MAX - 1) {
			PUTCARD(card[++sp], 0);
		}
		else {
			sp = _MAX;
		}
	}
	if (from == 1 || pos == 1) {
		temp = tableau;
		tableau = temp->next;
		XUnmapWindow(dpy, _decks[temp->n].self);
		if (temp->next != NULL) {
			py[1] = temp->next->tmp;
			PUTCARD(temp->next->n, 1);
		}
		else {
			py[1] = TOP_Y;
		}
		XtFree((XtPointer) temp);
	}
	if (edg == from && edg > 1) {
		if ((tmp = found[from - 2].ul) < 0) {
			goto trynext_f;
		}
		while (found[tmp].dl >= 0) {
			tmp = found[tmp].dl;
		}
		edg = tmp + 2;
		goto success_f;
trynext_f:
		if ((tmp = found[from - 2].ur) < 0) {
			goto tryover_f;
		}
		while (found[tmp].dr >= 0) {
			tmp = found[tmp].dr;
		}
		edg = tmp + 2;
		goto success_f;
tryover_f:
		edg = 1;
success_f:
		;
	}
	if (pos == 0) {
		if (sp >= _MAX) {
			pos = 1;
		}
	}
	else if (pos == 1) {
		if (tableau != NULL) {
			PUTCARD(tableau->n, 1);
		}
	}
	else {
		if ((tmp = found[pos - 2].ur) < 0) {
			goto trynext_p;
		}
		while (found[tmp].dr >= 0) {
			tmp = found[tmp].dr;
		}
		pos = tmp + 2;
		goto success_p;
trynext_p:
		if ((tmp = found[pos - 2].ul) < 0) {
			goto tryover_p;
		}
		while (found[tmp].dl >= 0) {
			tmp = found[tmp].dl;
		}
		pos = tmp + 2;
		goto success_p;
		tryover_p:
		pos = 1;
success_p:
		edg = pos;
	}
	holdcard = -1;
	havecard = False;
}

/******************************************************************************
  
stock pile            tableau
 /--\ /--\             /--\
 |  | |  |             |  |
 \--/ /--\           /--\/--\
      |  |           |  ||  |
      \--/         /--\/--\/--\
                   |  ||  ||  |
                 /--\/--\/--\/--\
                 |  ||  ||  ||  |
               /--\/--\/--\/--\/--\
               |  ||  ||  ||  ||  |
             /--\/--\/--\/--\/--\/--\
             |  ||  ||  ||  ||  ||  |
           /--\/--\/--\/--\/--\/--\/--\
           |  ||  ||  ||  ||  ||  ||  |
           \--/\--/\--/\--/\--/\--/\--/
******************************************************************************/
