/*
 * shuffle & draw !! 
 *
 * $Header: sad.c,v 0.5 94/10/31 15:17:30 miyazawa Rel $
 */

#include "modoki.h"

#define _MAX 52
#define _MIN 48
#define TOP_X 40
#define TOP_Y 20

static int card[_MIN];
static int found[4];
static int from;
static int holdcard;
static int shf;
static Boolean dend;
static struct tableau *tableau[16];
static int px[22], py[22];
static int whenHold();
static int whenNotHold();

void
initSad()
{
	int i, j;
	static int check();
	static void restart();

	_ckhook = check;
	_rshook = restart;
	_when_hold = whenHold;
	_when_not_hold = whenNotHold;
	current = SHUFFLE;
	(*_rshook)();
	(*_ckhook)();
}

static void
restart()
{
	int i, j;
	struct tableau *temp;
	
	srandom(randomseed);
	XUnmapSubwindows(dpy, Table);
	clearStack();

	for (j = 0, i = 0; i < _MAX; i++) {
		if (NUMB(i) != 0) {
			card[j++] = i;
		}
	}
	for (i = 0; i < _MIN; i++) {
		swap(&card[random() % _MIN], &card[i]);
	}
	for (i = 0; i < 5; i++) {
		px[i * 4] = TOP_X;
		px[i * 4 + 1] = TOP_X + 100;
		px[i * 4 + 2] = TOP_X + 200;
		px[i * 4 + 3] = TOP_X + 300;
		py[i * 4] =
		py[i * 4 + 1] =
		py[i * 4 + 2] =
		py[i * 4 + 3] = 70 * i + TOP_Y;
	}
	px[20] = TOP_X;
	py[20] = TOP_Y + 350;
	
	for (i = 0; i < 16; i++) {
		PUTCARD(FRAME, i);
		tfree(&tableau[i]);
		for (j = 0; j < 3; j++) {
			temp = talloc();
			temp->next = tableau[i];
			tableau[i] = temp;
			tableau[i]->n = card[i * 3 + j];
			PUTCARD(card[i * 3 + j], i);
			px[i] += 8;
		}
	}
	for (i = 0; i < 4; i++) {
		found[i] = i * 13;
		PUTCARD(i * 13, i + 16);
	}
	
	PUTCARD(FACE, 20);
	
	holdcard = -1;
	from = 0;
	shf = 2;
	dend = False;
	_status = 0;
}

static int
check()
{
	register i, j;
	int sou, des;
	int amax;

	autopilot = False;
	sou = des = -1;
	for (i = 0; i < 4; i++) {
		if (NUMB(found[i]) != KING) {
			goto skip;
		}
	}
	return (1);
skip:
	amax = 0;
	for (i = 0; i < 16; i++) {
		if (tableau[i] != NULL) {
			for (j = 0; j < 4; j++) {
				if (tableau[i]->n == found[j] + 1) {
					des = sou;
					sou = j + 16;
					goto ok;
				}
			}
			for (j = 0; j < 16; j++) {
				if (tableau[j] != NULL &&
				    tableau[j]->next != NULL &&
				    tableau[i]->n == tableau[j]->n + 1) {
					if (NUMB(tableau[i]->n) >= amax) {
						des = j;
						sou = i;
						amax = NUMB(tableau[i]->n);
					}
				}
			}
		}
	}
	if (des >= 0 || shf > 0 || !dend) {
		goto ok;
	}
	return (-1);
ok:
	return (0);
}

static int
whenNotHold(pos, num)
int pos;
int num;
{
	register i, j;
	int nmax;
	struct tableau *temp;

	if (pos >= 0 && pos < 16 && tableau[pos] != NULL) {
		if (tableau[pos]->n != num) {
			if (dend) {
				return (-1);
			}
			holdcard = num;
			from = pos;
			havecard = True;
			return (0);
		}
		holdcard = tableau[pos]->n;
		from = pos;
		for (i = 0; i < 4; i++) {
			if (found[i] + 1 == holdcard) {
				/*PUTCARD(found[i], i + 16);*/
				jumpMove(px[i + 16], py[i + 16], holdcard);
				_decks[holdcard].pos = i + 16;
				found[i]++;
				temp = tableau[from];
				tableau[from] = temp->next;
				XtFree((XtPointer) temp);
				if (tableau[from] != NULL) {
					px[from] -= 8;
				}
				holdcard = -1;
				return (0);
			}
		}
		for (i = 0; i < 16; i++) {
			if (tableau[i] != NULL &&
				tableau[i]->n - 1 == holdcard) {
				temp = tableau[from];
				tableau[from] = temp->next;
				temp->next = tableau[i];
				tableau[i] = temp;
				if (tableau[from] != NULL) {
					px[from] -= 8;
				}
				/*PUTCARD(tableau[i]->n, i);*/
				jumpMove(px[i], py[i], holdcard);
				_decks[holdcard].pos = i;
				px[i] += 8;
				holdcard = -1;
				return (0);
			}
		}
	}
	else if (pos == 20 && shf) {	/* shuffle */
		if (--shf == 0) {
			XUnmapWindow(dpy, _decks[JOKER + 20].self);
		}
		nmax = 0;
		for (i = 0; i < 16; i++) {
			if (tableau[i] == NULL) {
				px[i] -= 8;
			}
			else {
				for (temp = tableau[i]; temp != NULL;
				     temp = temp->next) {
					px[i] -= 8;
					card[nmax++] = temp->n;
				}
				tfree(&tableau[i]);
			}
		}
		for (i = 0; i < nmax; i++) {
			swap(&card[random() % nmax], &card[i]);
		}
		for (i = 0; i < 16; i++) {
			for (j = 0; j < 3; j++) {
				if (i * 3 + j >= nmax) {
					break;
				}
				temp = talloc();
				temp->next = tableau[i];
				tableau[i] = temp;
				tableau[i]->n = card[i * 3 + j];
				PUTCARD(card[i * 3 + j], i);
				px[i] += 8;
			}
		}
		return (0);
	}
	return (-1);
}

static int
whenHold(pos, num)
int pos;
int num;
{
	struct tableau *temp, *prev, *next;

	if (pos < 0) {
		holdcard = -1;
		return (-1);
	}
	for (temp = tableau[from]; temp != NULL; temp = temp->next) {
		if (temp->n == holdcard) {
			break;
		}
		prev = temp;
	}
	if (temp == NULL) {
		holdcard = -1;
		return (-1);
	}
	next = temp->next;
	if (pos >= 16 && pos <= 19) { /* foundation */
		if (holdcard == found[pos - 16] + 1) {
			found[pos - 16]++;
			tfree(&temp);
			PUTCARD(holdcard, pos);
		}
		else {
			holdcard = -1;
			return (-1);
		}
	}
	else if (pos < 16 && tableau[pos] != NULL) { /* tableau */
		if (holdcard == tableau[pos]->n - 1) {
			temp->next = tableau[pos];
			tableau[pos] = temp;
			PUTCARD(holdcard, pos);
			px[pos] += 8;
		}
		else {
			holdcard = -1;
			return (-1);
		}

	}
	else {
		holdcard = -1;
		return (-1);
	}
	prev->next = next;
	for (temp = tableau[from]; temp != NULL; temp = temp->next) {
		pushCard(temp);
		px[from] -= 8;
	}
	px[from] -= 8;
	while ((temp = popCard()) != NULL) {
		PUTCARD(temp->n, from);
		px[from] += 8;
	}
	dend = True;
	holdcard = -1;
	return (0);
}
