/*
 * towers !! 
 *
 * $Header: twr.c,v 0.8 94/10/31 15:17:31 miyazawa Rel $
 */

#include "modoki.h"

#define _MAX 52
#define TOP_X 32
#define TOP_Y 10
#define TAB 10

static int card[_MAX];
static int found[4];
static int from;
static int straight;
static int flex;
static int px[18], py[18];
static struct tableau *tower[4];
static struct tableau *tableau[TAB];
static struct tableau *holdcard;


void
initTwr()
{
	static int check();
	static void restart();
	static int whenHold();
	static int whenNotHold();
	register i;

	for (i = 0; i < 4; i++) {
		px[i + TAB] = TOP_X + 132 + 44 * i;
		py[i + TAB] = TOP_Y;
	}
	for (i = 0; i < 4; i++) {
		px[i + TAB + 4] = TOP_X + (i < 2 ? 0 : 264) + 44 * i;
		py[i + TAB + 4] = TOP_Y;
	}
	_ckhook = check;
	_rshook = restart;
	_when_hold = whenHold;
	_when_not_hold = whenNotHold;
	current = TOWERS;
	(*_rshook)();
	(*_ckhook)();
}

static void
restart()
{
	register i, j;
	struct tableau *temp;
	static long seed;

	srandom(randomseed);
	XUnmapSubwindows(dpy, Table);
	clearStack();

	for (i = 0; i < TAB; i++) {
		px[i] = TOP_X + 44 * i;
		py[i] = TOP_Y + 80;
	}
	for (i = 0; i < TAB; i++) {
		tfree(&tableau[i]);
	}

	for (i = 0; i < _MAX; i++) {
		card[i] = i;
	}
	for (i = 0; i < _MAX; i++) {
		swap(&card[random() % _MAX], &card[i]);
	}

	for (i = 0; i < 4; i++) {
		tfree(&tower[i]);
		PUTCARD(FRAME, i + TAB);
	}

	for (i = 0; i < 4; i++) {
		found[i] = i * 13 - 1;
	}

	for (i = 0; i < TAB; i++) {
		PUTCARD(FRAME, i);
		for (j = 0; j < 5; j++) {
			temp = talloc();
			temp->next = tableau[i];
			temp->n = card[i * 5 + j];
			tableau[i] = temp;
			PUTCARD(temp->n, i);
			py[i] += 20;
		}
		py[i] -= 20;
		PUTCARD(temp->n, i);
	}
	for (i = 0; i < 2; i++) {
		temp = talloc();
		temp->next = NULL;
		temp->n = card[50 + i];
		tower[i + 1] = temp;
		PUTCARD(temp->n, i + 11);
	}

	holdcard = NULL;
	havecard = False;
	straight = 0;
	from = 0;
	flex = 2;
	_status = 0;
}

static int
check()
{
	register i, j, k;
	int sou, des;
	int min;
	int vacant;
	struct tableau *temp;

	autopilot = False;
	sou = des = -1;
	for (i = 0; i < 4; i++) {
		for (j = 0; j < TAB; j++) {
			if (tableau[j] != NULL) {
				goto skip;
			}
		}
		for (j = 0; j < 4; j++) {
			if (tower[j] != NULL) {
				goto skip;
			}
		}
	}
	return (1);
skip:
	/* tower & foundation */
	for (i = 0; i < 4; i++) {
		if (tower[i] != NULL &&
			found[SUIT(tower[i]->n)] + 1 == tower[i]->n) {
			sou = i + TAB;
			des = SUIT(tower[i]->n) + 14;
			goto ok;
		}
	}
	/* tableau & foundation */
	for (i = 0; i < TAB; i++) {
		if (tableau[i] != NULL &&
			found[SUIT(tableau[i]->n)] + 1 == tableau[i]->n) {
			sou = i;
			des = SUIT(tableau[i]->n) + 14;
			goto ok;
		}
	}
	/* compare tableaus in seaquence */
	min = flex;
	for (i = 0; i < TAB; i++) {
		temp = tableau[i];
		for (k = 0; k < 4; k++) {
			if (tower[k] == NULL) {
				vacant = k + TAB;
				break;
			}
		}
		/* dig tableau in tower's empty number times */
		for (j = 0; j <= flex; j++) {
			int top;
			/* dag tableau & tower */
			for (k = 0; k < 4; k++) {
				if (tower[k] == NULL) {
					continue;
				}
				if (temp != NULL) {
					if (tower[k]->n + 1 == temp->n) {
						if (j) {
							sou = i;
							des = vacant;
						}
						else {
							sou = k + TAB;
							des = i;
						}
						goto ok;
					}
				}
				else {
					if (NUMB(tower[k]->n) == KING) {
						if (j) {
							sou = i;
							des = vacant;
						}
						else {
							sou = k + TAB;
							des = i;
						}
						goto ok;
					}
				}
			}
			if (temp == NULL) {
				if (min > j) {
					min = j;
				}
				break;
			}
			top = temp->n;
			/* dag tableau & other tableau */
			for (k = 0; k < TAB; k++) {
				if (i == k) {
					continue;
				}
				if (tableau[k] == NULL) {
					if (NUMB(temp->n) == KING
					    && temp->next != NULL) {
						sou = i;
						des = (temp->n - j != top) ?
							vacant : k;
						goto ok;
					}
				}
				else {
					if (temp->n + 1 == tableau[k]->n) {
						sou = i;
						des = (temp->n - j != top) ?
							vacant : k;
						goto ok;
					}
				}
			}
			/* dag tableau & foundation */
			if (found[SUIT(temp->n)] + 1 == temp->n) {
				sou = i;
				des = j ? vacant : SUIT(temp->n) + 14;
				goto ok;
			}
			temp = temp->next;
		}
	}
	/*
	 * when the King on tower & the card on tableau are able to swap
	 * and the Queen exist that continue to the King.
	 */
	if (min) {
		for (k = 0; k < 4; k++) {
			if (tower[k] != NULL && NUMB(tower[k]->n) == KING) {
				for (i = 0; i < TAB; i++) {
					temp = tableau[i];
					for (j = 0; j < min && temp != NULL;
						temp = temp->next, j++);
					if (temp != NULL &&
						temp->n + 1 == tower[k]->n &&
						temp->next != NULL) {
						sou = i;
						des = vacant;
						goto ok;
					}
				}
			}
		}
	}
	/* dead */
	return (-1);
ok:
	if (des > 13) {	/* the card exist that flies to foundation */
		autopilot = True;
		if (sou < TAB) {
			temp = tableau[sou];
			tableau[sou] = temp->next;
			temp->next = NULL;
			if (tableau[sou] != NULL) {
				py[sou] -= 20;
			}
		}
		else {
			temp = tower[sou - TAB];
			tower[sou - TAB] = NULL;
			flex++;
		}
		jumpMove(px[des], py[des], temp->n);
		_decks[temp->n].pos = des;
		found[des - TAB - 4]++;
		tfree(&temp);
		havecard = False;
	}
	return (0);
}

static int
whenNotHold(pos)
int pos;
{
	struct tableau *temp;

	if (pos < 0) {
		return (-1);
	}
	else if (pos < TAB) {
		if (tableau[pos] != NULL) {
			for (straight = 0, temp = tableau[pos];
			     temp->next != NULL &&
			     BINDP(temp->n, temp->next->n);
			     straight++, temp = temp->next);
			from = pos;
			holdcard = temp;
			havecard = True;
			return (0);
		}
	}
	else if (pos < TAB + 4) {
		if (tower[pos - TAB] != NULL) {
			straight = 0;
			holdcard = tower[pos - TAB];
			havecard = True;
			from = pos;
			return (0);
		}
	}
	return (-1);
}

static int
whenHold(pos)
int pos;
{
	register i;
	struct tableau *temp;
	struct tableau *head;

	if (pos == from || pos < 0) {
		holdcard = NULL;
		return (-1);
	}
	if (pos < TAB) {
		if (straight <= flex) {
			/* tower or tableau to tableau */
			if (tableau[pos] == NULL) {
				if (NUMB(holdcard->n) == KING) {
					goto ok;
				}
			}
			else {
				if (BINDP(holdcard->n, tableau[pos]->n)) {
					goto ok;
				}
			}
		}
	}
	else if (from < TAB) {	/* tableau to tower */
		if (tower[pos - TAB] == NULL) {
			straight = 0;
			holdcard = tableau[from];
			goto ok;
		}
	}
	holdcard = NULL;
	return (-1);

ok:
	if (from < TAB) {
		head = tableau[from];
		temp = holdcard->next;
		head = tableau[from];
		tableau[from] = temp;
		for (i = 0; i < straight; i++) {
			py[from] -= 20;
		}
		if (temp != NULL) {
			py[from] -= 20;
			PUTCARD(temp->n, from);
		}
	}
	else {
		head = tower[from - TAB];
		tower[from - TAB] = NULL;
		flex++;
	}
	if (pos < TAB) {
		holdcard->next = tableau[pos];
		tableau[pos] = head;
		temp = tableau[pos];
		py[pos] -= holdcard->next == NULL ? 20 : 0;
		for (i = 0; i <= straight; i++) {
			pushCard(temp);
			temp = temp->next;
		}
		while (temp = popCard()) {
			py[pos] += 20;
			PUTCARD(temp->n, pos);
		}
	}
	else if (pos < TAB + 4) {
		head->next = NULL;
		PUTCARD(head->n, pos);
		tower[pos - TAB] = head;
		flex--;
	}
	holdcard = NULL;
	return (0);
}
